// Generated by gencpp from file ld_msgs/ld_imu.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_IMU_H
#define LD_MSGS_MESSAGE_LD_IMU_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <geometry_msgs/Quaternion.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>
#include <geometry_msgs/Vector3.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_imu_
{
  typedef ld_imu_<ContainerAllocator> Type;

  ld_imu_()
    : header()
    , utctime()
    , timestamps(0.0)
    , orientation()
    , orientation_covariance()
    , angular_velocity()
    , angular_velocity_covariance()
    , linear_acceleration()
    , linear_acceleration_covariance()
    , roll_pitch_yaw()
    , roll_pitch_yaw_covariance()  {
      orientation_covariance.assign(0.0);

      angular_velocity_covariance.assign(0.0);

      linear_acceleration_covariance.assign(0.0);

      roll_pitch_yaw_covariance.assign(0.0);
  }
  ld_imu_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , utctime(_alloc)
    , timestamps(0.0)
    , orientation(_alloc)
    , orientation_covariance()
    , angular_velocity(_alloc)
    , angular_velocity_covariance()
    , linear_acceleration(_alloc)
    , linear_acceleration_covariance()
    , roll_pitch_yaw(_alloc)
    , roll_pitch_yaw_covariance()  {
  (void)_alloc;
      orientation_covariance.assign(0.0);

      angular_velocity_covariance.assign(0.0);

      linear_acceleration_covariance.assign(0.0);

      roll_pitch_yaw_covariance.assign(0.0);
  }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _utctime_type;
  _utctime_type utctime;

   typedef double _timestamps_type;
  _timestamps_type timestamps;

   typedef  ::geometry_msgs::Quaternion_<ContainerAllocator>  _orientation_type;
  _orientation_type orientation;

   typedef boost::array<double, 9>  _orientation_covariance_type;
  _orientation_covariance_type orientation_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _angular_velocity_type;
  _angular_velocity_type angular_velocity;

   typedef boost::array<double, 9>  _angular_velocity_covariance_type;
  _angular_velocity_covariance_type angular_velocity_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _linear_acceleration_type;
  _linear_acceleration_type linear_acceleration;

   typedef boost::array<double, 9>  _linear_acceleration_covariance_type;
  _linear_acceleration_covariance_type linear_acceleration_covariance;

   typedef  ::geometry_msgs::Vector3_<ContainerAllocator>  _roll_pitch_yaw_type;
  _roll_pitch_yaw_type roll_pitch_yaw;

   typedef boost::array<double, 9>  _roll_pitch_yaw_covariance_type;
  _roll_pitch_yaw_covariance_type roll_pitch_yaw_covariance;





  typedef boost::shared_ptr< ::ld_msgs::ld_imu_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_imu_<ContainerAllocator> const> ConstPtr;

}; // struct ld_imu_

typedef ::ld_msgs::ld_imu_<std::allocator<void> > ld_imu;

typedef boost::shared_ptr< ::ld_msgs::ld_imu > ld_imuPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_imu const> ld_imuConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_imu_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_imu_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/lddev001/catkin_ws/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_imu_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_imu_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_imu_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_imu_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_imu_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_imu_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_imu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "f374e546f1105b621e02b927de460caf";
  }

  static const char* value(const ::ld_msgs::ld_imu_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xf374e546f1105b62ULL;
  static const uint64_t static_value2 = 0x1e02b927de460cafULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_imu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_imu";
  }

  static const char* value(const ::ld_msgs::ld_imu_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_imu_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Header header\n\
\n\
string utctime\n\
\n\
float64 timestamps\n\
\n\
geometry_msgs/Quaternion orientation\n\
float64[9] orientation_covariance # Row major about x, y, z axes\n\
\n\
geometry_msgs/Vector3 angular_velocity\n\
float64[9] angular_velocity_covariance # Row major about x, y, z axes\n\
\n\
geometry_msgs/Vector3 linear_acceleration\n\
float64[9] linear_acceleration_covariance # Row major x, y z \n\
\n\
geometry_msgs/Vector3 roll_pitch_yaw\n\
float64[9] roll_pitch_yaw_covariance\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
# It is only meant to represent a direction. Therefore, it does not\n\
# make sense to apply a translation to it (e.g., when applying a \n\
# generic rigid transformation to a Vector3, tf2 will only apply the\n\
# rotation). If you want your data to be translatable too, use the\n\
# geometry_msgs/Point message instead.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
";
  }

  static const char* value(const ::ld_msgs::ld_imu_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_imu_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.utctime);
      stream.next(m.timestamps);
      stream.next(m.orientation);
      stream.next(m.orientation_covariance);
      stream.next(m.angular_velocity);
      stream.next(m.angular_velocity_covariance);
      stream.next(m.linear_acceleration);
      stream.next(m.linear_acceleration_covariance);
      stream.next(m.roll_pitch_yaw);
      stream.next(m.roll_pitch_yaw_covariance);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_imu_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_imu_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_imu_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "utctime: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.utctime);
    s << indent << "timestamps: ";
    Printer<double>::stream(s, indent + "  ", v.timestamps);
    s << indent << "orientation: ";
    s << std::endl;
    Printer< ::geometry_msgs::Quaternion_<ContainerAllocator> >::stream(s, indent + "  ", v.orientation);
    s << indent << "orientation_covariance[]" << std::endl;
    for (size_t i = 0; i < v.orientation_covariance.size(); ++i)
    {
      s << indent << "  orientation_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.orientation_covariance[i]);
    }
    s << indent << "angular_velocity: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.angular_velocity);
    s << indent << "angular_velocity_covariance[]" << std::endl;
    for (size_t i = 0; i < v.angular_velocity_covariance.size(); ++i)
    {
      s << indent << "  angular_velocity_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.angular_velocity_covariance[i]);
    }
    s << indent << "linear_acceleration: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.linear_acceleration);
    s << indent << "linear_acceleration_covariance[]" << std::endl;
    for (size_t i = 0; i < v.linear_acceleration_covariance.size(); ++i)
    {
      s << indent << "  linear_acceleration_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.linear_acceleration_covariance[i]);
    }
    s << indent << "roll_pitch_yaw: ";
    s << std::endl;
    Printer< ::geometry_msgs::Vector3_<ContainerAllocator> >::stream(s, indent + "  ", v.roll_pitch_yaw);
    s << indent << "roll_pitch_yaw_covariance[]" << std::endl;
    for (size_t i = 0; i < v.roll_pitch_yaw_covariance.size(); ++i)
    {
      s << indent << "  roll_pitch_yaw_covariance[" << i << "]: ";
      Printer<double>::stream(s, indent + "  ", v.roll_pitch_yaw_covariance[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_IMU_H
